<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">SDL.GPU.Simple.TargetControls</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-2"></span><span>
</span><span id="line-3"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Int</span></span><span>
</span><span id="line-4"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.Word</span></span><span>
</span><span id="line-5"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Ptr</span></span><span>
</span><span id="line-6"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Utils</span></span><span>
</span><span id="line-7"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Marshal.Alloc</span></span><span>
</span><span id="line-8"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Foreign.Storable</span></span><span>
</span><span id="line-9"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad.IO.Class</span></span><span>
</span><span id="line-10"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Linear.V2</span></span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="SDL.GPU.C.html"><span class="hs-identifier">SDL.GPU.C</span></a></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">GPU</span></span><span>
</span><span id="line-13"></span><span>
</span><span id="line-14"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#createAliasTarget"><span class="hs-identifier hs-type">createAliasTarget</span></a></span><span>
</span><span id="line-15"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191840"><span class="annot"><a href="#local-6989586621679191840"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-16"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191840"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-17"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-18"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191840"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-19"></span><span id="createAliasTarget"><span class="annot"><span class="annottext">createAliasTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.TargetControls.html#createAliasTarget"><span class="hs-identifier hs-var hs-var">createAliasTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.TargetControls.html#createAliasTarget"><span class="hs-identifier hs-var">GPU.createAliasTarget</span></a></span><span>
</span><span id="line-20"></span><span>
</span><span id="line-21"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#loadTarget"><span class="hs-identifier hs-type">loadTarget</span></a></span><span>
</span><span id="line-22"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191831"><span class="annot"><a href="#local-6989586621679191831"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-23"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191831"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-24"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-25"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191831"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-26"></span><span id="loadTarget"><span class="annot"><span class="annottext">loadTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.TargetControls.html#loadTarget"><span class="hs-identifier hs-var hs-var">loadTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.TargetControls.html#loadTarget"><span class="hs-identifier hs-var">GPU.loadTarget</span></a></span><span>
</span><span id="line-27"></span><span>
</span><span id="line-28"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#getTarget"><span class="hs-identifier hs-type">getTarget</span></a></span><span>
</span><span id="line-29"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191759"><span class="annot"><a href="#local-6989586621679191759"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-30"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191759"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Image"><span class="hs-identifier hs-type">GPU.Image</span></a></span><span>
</span><span id="line-32"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191759"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-33"></span><span id="getTarget"><span class="annot"><span class="annottext">getTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Image -&gt; m (Ptr Target)
</span><a href="SDL.GPU.Simple.TargetControls.html#getTarget"><span class="hs-identifier hs-var hs-var">getTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Image -&gt; IO (Ptr Target)
</span><a href="SDL.GPU.C.TargetControls.html#getTarget"><span class="hs-identifier hs-var">GPU.getTarget</span></a></span><span>
</span><span id="line-34"></span><span>
</span><span id="line-35"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#freeTarget"><span class="hs-identifier hs-type">freeTarget</span></a></span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191827"><span class="annot"><a href="#local-6989586621679191827"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-37"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191827"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-39"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191827"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-40"></span><span id="freeTarget"><span class="annot"><span class="annottext">freeTarget :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#freeTarget"><span class="hs-identifier hs-var hs-var">freeTarget</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#freeTarget"><span class="hs-identifier hs-var">GPU.freeTarget</span></a></span><span>
</span><span id="line-41"></span><span>
</span><span id="line-42"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#setVirtualResolution"><span class="hs-identifier hs-type">setVirtualResolution</span></a></span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191825"><span class="annot"><a href="#local-6989586621679191825"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-44"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191825"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-45"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-46"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ w</span><span>
</span><span id="line-47"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span> </span><span class="hs-comment">-- ^ h</span><span>
</span><span id="line-48"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191825"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-49"></span><span id="setVirtualResolution"><span class="annot"><span class="annottext">setVirtualResolution :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Target -&gt; Uint16 -&gt; Uint16 -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#setVirtualResolution"><span class="hs-identifier hs-var hs-var">setVirtualResolution</span></a></span></span><span> </span><span id="local-6989586621679191748"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191748"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679191747"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679191747"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span id="local-6989586621679191746"><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679191746"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Uint16 -&gt; Uint16 -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#setVirtualResolution"><span class="hs-identifier hs-var">GPU.setVirtualResolution</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191748"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679191747"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Uint16
</span><a href="#local-6989586621679191746"><span class="hs-identifier hs-var">h</span></a></span><span>
</span><span id="line-50"></span><span>
</span><span id="line-51"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#getVirtualResolution"><span class="hs-identifier hs-type">getVirtualResolution</span></a></span><span>
</span><span id="line-52"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191819"><span class="annot"><a href="#local-6989586621679191819"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-53"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191819"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-54"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-55"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191819"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V2</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint16"><span class="hs-identifier hs-type">GPU.Uint16</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-comment">-- ^ (w, h)</span><span>
</span><span id="line-56"></span><span id="getVirtualResolution"><span class="annot"><span class="annottext">getVirtualResolution :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m (V2 Uint16)
</span><a href="SDL.GPU.Simple.TargetControls.html#getVirtualResolution"><span class="hs-identifier hs-var hs-var">getVirtualResolution</span></a></span></span><span> </span><span id="local-6989586621679191730"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191730"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679191728"><span class="annot"><span class="annottext">Ptr Uint16
</span><a href="#local-6989586621679191728"><span class="hs-identifier hs-var">w</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679191727"><span class="annot"><span class="annottext">Ptr Uint16
</span><a href="#local-6989586621679191727"><span class="hs-identifier hs-var">h</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-57"></span><span>  </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Uint16 -&gt; Ptr Uint16 -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#getVirtualResolution"><span class="hs-identifier hs-var">GPU.getVirtualResolution</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191730"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Uint16
</span><a href="#local-6989586621679191728"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Uint16
</span><a href="#local-6989586621679191727"><span class="hs-identifier hs-var">h</span></a></span><span>
</span><span id="line-58"></span><span>  </span><span class="annot"><span class="annottext">forall a. a -&gt; a -&gt; V2 a
</span><span class="hs-identifier hs-var">V2</span></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Uint16
</span><a href="#local-6989586621679191728"><span class="hs-identifier hs-var">w</span></a></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Applicative f =&gt; f (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;*&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Uint16
</span><a href="#local-6989586621679191727"><span class="hs-identifier hs-var">h</span></a></span><span>
</span><span id="line-59"></span><span>
</span><span id="line-60"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#getVirtualCoords"><span class="hs-identifier hs-type">getVirtualCoords</span></a></span><span>
</span><span id="line-61"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191805"><span class="annot"><a href="#local-6989586621679191805"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-62"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191805"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-63"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-64"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">V2</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span> </span><span class="hs-comment">-- ^ display</span><span>
</span><span id="line-65"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191805"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V2</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Float"><span class="hs-identifier hs-type">GPU.Float</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-66"></span><span id="getVirtualCoords"><span class="annot"><span class="annottext">getVirtualCoords :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Target -&gt; V2 Float -&gt; m (V2 Float)
</span><a href="SDL.GPU.Simple.TargetControls.html#getVirtualCoords"><span class="hs-identifier hs-var hs-var">getVirtualCoords</span></a></span></span><span> </span><span id="local-6989586621679191711"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191711"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V2</span></span><span> </span><span id="local-6989586621679191710"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679191710"><span class="hs-identifier hs-var">displayX</span></a></span></span><span> </span><span id="local-6989586621679191709"><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679191709"><span class="hs-identifier hs-var">displayY</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679191708"><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679191708"><span class="hs-identifier hs-var">x</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679191707"><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679191707"><span class="hs-identifier hs-var">y</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-67"></span><span>  </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Float -&gt; Ptr Float -&gt; Float -&gt; Float -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#getVirtualCoords"><span class="hs-identifier hs-var">GPU.getVirtualCoords</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191711"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679191708"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679191707"><span class="hs-identifier hs-var">y</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679191710"><span class="hs-identifier hs-var">displayX</span></a></span><span> </span><span class="annot"><span class="annottext">Float
</span><a href="#local-6989586621679191709"><span class="hs-identifier hs-var">displayY</span></a></span><span>
</span><span id="line-68"></span><span>  </span><span class="annot"><span class="annottext">forall a. a -&gt; a -&gt; V2 a
</span><span class="hs-identifier hs-var">V2</span></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679191708"><span class="hs-identifier hs-var">x</span></a></span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Applicative f =&gt; f (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;*&gt;</span></span><span> </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Float
</span><a href="#local-6989586621679191707"><span class="hs-identifier hs-var">y</span></a></span><span>
</span><span id="line-69"></span><span>
</span><span id="line-70"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#unsetVirtualResolution"><span class="hs-identifier hs-type">unsetVirtualResolution</span></a></span><span>
</span><span id="line-71"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191704"><span class="annot"><a href="#local-6989586621679191704"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-72"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191704"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-73"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-74"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191704"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-75"></span><span id="unsetVirtualResolution"><span class="annot"><span class="annottext">unsetVirtualResolution :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#unsetVirtualResolution"><span class="hs-identifier hs-var hs-var">unsetVirtualResolution</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#unsetVirtualResolution"><span class="hs-identifier hs-var">GPU.unsetVirtualResolution</span></a></span><span>
</span><span id="line-76"></span><span>
</span><span id="line-77"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#setViewport"><span class="hs-identifier hs-type">setViewport</span></a></span><span>
</span><span id="line-78"></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191801"><span class="annot"><a href="#local-6989586621679191801"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-79"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191801"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-80"></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-81"></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Rect"><span class="hs-identifier hs-type">GPU.Rect</span></a></span><span>
</span><span id="line-82"></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191801"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-83"></span><span id="setViewport"><span class="annot"><span class="annottext">setViewport :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; Rect -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#setViewport"><span class="hs-identifier hs-var hs-var">setViewport</span></a></span></span><span> </span><span id="local-6989586621679191695"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191695"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679191694"><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679191694"><span class="hs-identifier hs-var">rect</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Rect
</span><a href="#local-6989586621679191694"><span class="hs-identifier hs-var">rect</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Rect -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#setViewport"><span class="hs-identifier hs-var">GPU.setViewport</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191695"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-84"></span><span>
</span><span id="line-85"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#unsetViewport"><span class="hs-identifier hs-type">unsetViewport</span></a></span><span>
</span><span id="line-86"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191690"><span class="annot"><a href="#local-6989586621679191690"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-87"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191690"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-88"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-89"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191690"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-90"></span><span id="unsetViewport"><span class="annot"><span class="annottext">unsetViewport :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#unsetViewport"><span class="hs-identifier hs-var hs-var">unsetViewport</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#unsetViewport"><span class="hs-identifier hs-var">GPU.unsetViewport</span></a></span><span>
</span><span id="line-91"></span><span>
</span><span id="line-92"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#getCamera"><span class="hs-identifier hs-type">getCamera</span></a></span><span>
</span><span id="line-93"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191795"><span class="annot"><a href="#local-6989586621679191795"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-94"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191795"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-95"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-96"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191795"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Camera"><span class="hs-identifier hs-type">GPU.Camera</span></a></span><span>
</span><span id="line-97"></span><span id="getCamera"><span class="annot"><span class="annottext">getCamera :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m Camera
</span><a href="SDL.GPU.Simple.TargetControls.html#getCamera"><span class="hs-identifier hs-var hs-var">getCamera</span></a></span></span><span> </span><span id="local-6989586621679191679"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191679"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-98"></span><span>  </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679191678"><span class="annot"><span class="annottext">Ptr Camera
</span><a href="#local-6989586621679191678"><span class="hs-identifier hs-var">cam</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-99"></span><span>    </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Camera -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#getCamera"><span class="hs-identifier hs-var">GPU.getCamera</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191679"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Camera
</span><a href="#local-6989586621679191678"><span class="hs-identifier hs-var">cam</span></a></span><span>
</span><span id="line-100"></span><span>    </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Camera
</span><a href="#local-6989586621679191678"><span class="hs-identifier hs-var">cam</span></a></span><span>
</span><span id="line-101"></span><span>
</span><span id="line-102"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#setCamera"><span class="hs-identifier hs-type">setCamera</span></a></span><span>
</span><span id="line-103"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191792"><span class="annot"><a href="#local-6989586621679191792"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-104"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191792"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-105"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-106"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Camera"><span class="hs-identifier hs-type">GPU.Camera</span></a></span><span> </span><span class="hs-comment">-- ^ new camera</span><span>
</span><span id="line-107"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191792"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-108"></span><span id="setCamera"><span class="annot"><span class="annottext">setCamera :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; Camera -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#setCamera"><span class="hs-identifier hs-var hs-var">setCamera</span></a></span></span><span> </span><span id="local-6989586621679191672"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191672"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679191671"><span class="annot"><span class="annottext">Camera
</span><a href="#local-6989586621679191671"><span class="hs-identifier hs-var">cam</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Camera
</span><a href="#local-6989586621679191671"><span class="hs-identifier hs-var">cam</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Camera -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#setCamera"><span class="hs-identifier hs-var">GPU.setCamera</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191672"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-109"></span><span>
</span><span id="line-110"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#getDefaultCamera"><span class="hs-identifier hs-type">getDefaultCamera</span></a></span><span>
</span><span id="line-111"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191790"><span class="annot"><a href="#local-6989586621679191790"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-112"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191790"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-113"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191790"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Camera"><span class="hs-identifier hs-type">GPU.Camera</span></a></span><span> </span><span class="hs-comment">-- ^ out</span><span>
</span><span id="line-114"></span><span id="getDefaultCamera"><span class="annot"><span class="annottext">getDefaultCamera :: forall (m :: * -&gt; *). MonadIO m =&gt; m Camera
</span><a href="SDL.GPU.Simple.TargetControls.html#getDefaultCamera"><span class="hs-identifier hs-var hs-var">getDefaultCamera</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">alloca</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679191663"><span class="annot"><span class="annottext">Ptr Camera
</span><a href="#local-6989586621679191663"><span class="hs-identifier hs-var">cam</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-115"></span><span>  </span><span class="annot"><span class="annottext">Ptr Camera -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#getDefaultCamera"><span class="hs-identifier hs-var">GPU.getDefaultCamera</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Camera
</span><a href="#local-6989586621679191663"><span class="hs-identifier hs-var">cam</span></a></span><span>
</span><span id="line-116"></span><span>  </span><span class="annot"><span class="annottext">forall a. Storable a =&gt; Ptr a -&gt; IO a
</span><span class="hs-identifier hs-var">peek</span></span><span> </span><span class="annot"><span class="annottext">Ptr Camera
</span><a href="#local-6989586621679191663"><span class="hs-identifier hs-var">cam</span></a></span><span>
</span><span id="line-117"></span><span>
</span><span id="line-118"></span><span class="hs-comment">-- TODO: setCameraReturning</span><span>
</span><span id="line-119"></span><span>
</span><span id="line-120"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#enableCamera"><span class="hs-identifier hs-type">enableCamera</span></a></span><span>
</span><span id="line-121"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191788"><span class="annot"><a href="#local-6989586621679191788"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-122"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191788"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-123"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-124"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span> </span><span class="hs-comment">-- ^ use_camera</span><span>
</span><span id="line-125"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191788"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-126"></span><span id="enableCamera"><span class="annot"><span class="annottext">enableCamera :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; Bool -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#enableCamera"><span class="hs-identifier hs-var hs-var">enableCamera</span></a></span></span><span> </span><span id="local-6989586621679191658"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191658"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Bool -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#enableCamera"><span class="hs-identifier hs-var">GPU.enableCamera</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191658"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#bool"><span class="hs-identifier hs-var">GPU.bool</span></a></span><span>
</span><span id="line-127"></span><span>
</span><span id="line-128"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#isCameraEnabled"><span class="hs-identifier hs-type">isCameraEnabled</span></a></span><span>
</span><span id="line-129"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191785"><span class="annot"><a href="#local-6989586621679191785"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-130"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191785"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-131"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-132"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191785"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Prelude.Bool</span></span><span>
</span><span id="line-133"></span><span id="isCameraEnabled"><span class="annot"><span class="annottext">isCameraEnabled :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m Bool
</span><a href="SDL.GPU.Simple.TargetControls.html#isCameraEnabled"><span class="hs-identifier hs-var hs-var">isCameraEnabled</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Bool -&gt; Bool
</span><a href="SDL.GPU.C.Bool.html#isTrue"><span class="hs-identifier hs-var">GPU.isTrue</span></a></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO Bool
</span><a href="SDL.GPU.C.TargetControls.html#isCameraEnabled"><span class="hs-identifier hs-var">GPU.isCameraEnabled</span></a></span><span>
</span><span id="line-134"></span><span>
</span><span id="line-135"></span><span class="hs-comment">-- TODO: Depth stuff</span><span>
</span><span id="line-136"></span><span>
</span><span id="line-137"></span><span class="hs-comment">-- TODO: getPixel</span><span>
</span><span id="line-138"></span><span>
</span><span id="line-139"></span><span class="hs-comment">-- TODO: Clip stuff</span><span>
</span><span id="line-140"></span><span>
</span><span id="line-141"></span><span class="hs-comment">-- TODO: insertsects</span><span>
</span><span id="line-142"></span><span>
</span><span id="line-143"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#setTargetColor"><span class="hs-identifier hs-type">setTargetColor</span></a></span><span>
</span><span id="line-144"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191779"><span class="annot"><a href="#local-6989586621679191779"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-145"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191779"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-146"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-147"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">GPU.Color</span></span><span>
</span><span id="line-148"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191779"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-149"></span><span id="setTargetColor"><span class="annot"><span class="annottext">setTargetColor :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; Color -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#setTargetColor"><span class="hs-identifier hs-var hs-var">setTargetColor</span></a></span></span><span> </span><span id="local-6989586621679191638"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191638"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679191637"><span class="annot"><span class="annottext">Color
</span><a href="#local-6989586621679191637"><span class="hs-identifier hs-var">c</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">forall a b. Storable a =&gt; a -&gt; (Ptr a -&gt; IO b) -&gt; IO b
</span><span class="hs-identifier hs-var">with</span></span><span> </span><span class="annot"><span class="annottext">Color
</span><a href="#local-6989586621679191637"><span class="hs-identifier hs-var">c</span></a></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Ptr Color -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#setTargetColor"><span class="hs-identifier hs-var">GPU.setTargetColor</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191638"><span class="hs-identifier hs-var">t</span></a></span><span>
</span><span id="line-150"></span><span>
</span><span id="line-151"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#setTargetRGB"><span class="hs-identifier hs-type">setTargetRGB</span></a></span><span>
</span><span id="line-152"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191776"><span class="annot"><a href="#local-6989586621679191776"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-153"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191776"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-154"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-155"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ r</span><span>
</span><span id="line-156"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ g</span><span>
</span><span id="line-157"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ b</span><span>
</span><span id="line-158"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191776"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-159"></span><span id="setTargetRGB"><span class="annot"><span class="annottext">setTargetRGB :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Target -&gt; Uint8 -&gt; Uint8 -&gt; Uint8 -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#setTargetRGB"><span class="hs-identifier hs-var hs-var">setTargetRGB</span></a></span></span><span> </span><span id="local-6989586621679191632"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191632"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679191631"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191631"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span id="local-6989586621679191630"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191630"><span class="hs-identifier hs-var">g</span></a></span></span><span> </span><span id="local-6989586621679191629"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191629"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Uint8 -&gt; Uint8 -&gt; Uint8 -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#setTargetRGB"><span class="hs-identifier hs-var">GPU.setTargetRGB</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191632"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191631"><span class="hs-identifier hs-var">r</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191630"><span class="hs-identifier hs-var">g</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191629"><span class="hs-identifier hs-var">b</span></a></span><span>
</span><span id="line-160"></span><span>
</span><span id="line-161"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#setTargetRGBA"><span class="hs-identifier hs-type">setTargetRGBA</span></a></span><span>
</span><span id="line-162"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191773"><span class="annot"><a href="#local-6989586621679191773"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-163"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191773"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-164"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-165"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ r</span><span>
</span><span id="line-166"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ g</span><span>
</span><span id="line-167"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ b</span><span>
</span><span id="line-168"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="SDL.GPU.C.NumericTypes.html#Uint8"><span class="hs-identifier hs-type">GPU.Uint8</span></a></span><span> </span><span class="hs-comment">-- ^ a</span><span>
</span><span id="line-169"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191773"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-170"></span><span id="setTargetRGBA"><span class="annot"><span class="annottext">setTargetRGBA :: forall (m :: * -&gt; *).
MonadIO m =&gt;
Ptr Target -&gt; Uint8 -&gt; Uint8 -&gt; Uint8 -&gt; Uint8 -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#setTargetRGBA"><span class="hs-identifier hs-var hs-var">setTargetRGBA</span></a></span></span><span> </span><span id="local-6989586621679191624"><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191624"><span class="hs-identifier hs-var">t</span></a></span></span><span> </span><span id="local-6989586621679191623"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191623"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span id="local-6989586621679191622"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191622"><span class="hs-identifier hs-var">g</span></a></span></span><span> </span><span id="local-6989586621679191621"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191621"><span class="hs-identifier hs-var">b</span></a></span></span><span> </span><span id="local-6989586621679191620"><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191620"><span class="hs-identifier hs-var">a</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; Uint8 -&gt; Uint8 -&gt; Uint8 -&gt; Uint8 -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#setTargetRGBA"><span class="hs-identifier hs-var">GPU.setTargetRGBA</span></a></span><span> </span><span class="annot"><span class="annottext">Ptr Target
</span><a href="#local-6989586621679191624"><span class="hs-identifier hs-var">t</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191623"><span class="hs-identifier hs-var">r</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191622"><span class="hs-identifier hs-var">g</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191621"><span class="hs-identifier hs-var">b</span></a></span><span> </span><span class="annot"><span class="annottext">Uint8
</span><a href="#local-6989586621679191620"><span class="hs-identifier hs-var">a</span></a></span><span>
</span><span id="line-171"></span><span>
</span><span id="line-172"></span><span class="annot"><a href="SDL.GPU.Simple.TargetControls.html#unsetTargetColor"><span class="hs-identifier hs-type">unsetTargetColor</span></a></span><span>
</span><span id="line-173"></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="hs-keyword">forall</span><span> </span><span id="local-6989586621679191617"><span class="annot"><a href="#local-6989586621679191617"><span class="hs-identifier hs-type">m</span></a></span></span><span>
</span><span id="line-174"></span><span>   </span><span class="hs-operator">.</span><span> </span><span class="annot"><span class="hs-identifier hs-type">MonadIO</span></span><span> </span><span class="annot"><a href="#local-6989586621679191617"><span class="hs-identifier hs-type">m</span></a></span><span>
</span><span id="line-175"></span><span>  </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Ptr</span></span><span> </span><span class="annot"><a href="SDL.GPU.C.Types.html#Target"><span class="hs-identifier hs-type">GPU.Target</span></a></span><span>
</span><span id="line-176"></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="#local-6989586621679191617"><span class="hs-identifier hs-type">m</span></a></span><span> </span><span class="hs-special">(</span><span class="hs-special">)</span><span>
</span><span id="line-177"></span><span id="unsetTargetColor"><span class="annot"><span class="annottext">unsetTargetColor :: forall (m :: * -&gt; *). MonadIO m =&gt; Ptr Target -&gt; m ()
</span><a href="SDL.GPU.Simple.TargetControls.html#unsetTargetColor"><span class="hs-identifier hs-var hs-var">unsetTargetColor</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">forall (m :: * -&gt; *) a. MonadIO m =&gt; IO a -&gt; m a
</span><span class="hs-identifier hs-var">liftIO</span></span><span> </span><span class="annot"><span class="annottext">forall b c a. (b -&gt; c) -&gt; (a -&gt; b) -&gt; a -&gt; c
</span><span class="hs-operator hs-var">.</span></span><span> </span><span class="annot"><span class="annottext">Ptr Target -&gt; IO ()
</span><a href="SDL.GPU.C.TargetControls.html#unsetTargetColor"><span class="hs-identifier hs-var">GPU.unsetTargetColor</span></a></span><span>
</span><span id="line-178"></span></pre></body></html>